
surface shadowcollector(float Ka = 1, Kd = 1, shadowLimit = 0.1;
                        color surfaceCol=1., shadowCol = 0.;) {

   color Ct=Cs;
   
   normal Nf=faceforward(normalize(N),I);
   vector V=-normalize(I); 
   Ci=(Ct*(Ka*ambient() + Kd*diffuse(Nf)));

   /* retain shadows and make all other colours constant */
   float col1,s1,s2,s3,mult;
   col1=comp(Ci,0);
   mult=1-col1;

   s1=comp(shadowCol,0)*mult;
   s2=comp(shadowCol,1)*mult;
   s3=comp(shadowCol,2)*mult;


   if(col1>shadowLimit) { Ci=surfaceCol; }

    else {
      setcomp(Ci,0,s1);
      setcomp(Ci,1,s2);
      setcomp(Ci,2,s3);
    }

   Oi=Os; 
   Ci*=Oi;
}
