/* nizid utility shader */


surface nizid( float near = 0;
               float far = 1;)
{

  varying float ni;
  varying float zee;
  varying float col;
  
  /* detect silhoettes */
  ni=N.I;
  ni=(ni*ni)/(N.N*I.I);
  ni=1.-sqrt(ni);

  /* create z map */
  zee=1.-clamp((depth(P)-near)/(far-near),0,1);

  /* colour back differently to front */
  /*if(faceforward(N,I).N>=0.0) { col=1; }
   else {col=0.5; }*/
  col=1;

  Ci=color "rgb" (ni,zee,col);
  Oi=1.;

}
               
